# Privacy Friendly Shopping List

[<img src="https://f-droid.org/badge/get-it-on.png" alt="Get it on F-Droid" height="60">](https://f-droid.org/repository/browse/?fdid=privacyfriendlyshoppinglist.secuso.org.privacyfriendlyshoppinglist)<a href="https://play.google.com/store/apps/details?id=privacyfriendlyshoppinglist.secuso.org.privacyfriendlyshoppinglist"><img src="https://play.google.com/intl/en_us/badges/images/generic/en_badge_web_generic.png" height="60"></a>

The Privacy Friendly App Shopping List is an Android application that does not require any permissions from the user in order to be installed. With this app users will be able to manage their shopping lists. Basically users will be able to add, edit and remove lists. A shopping list contains products which can be added, edited and removed as well.

## Motivation

Nowadays there are many apps that require many or all permissions available in Android in order to be installed. However these apps do not always need all of the permissions they ask for. With this project we want to offer an app where the user can be sure that private information such as contacts, location, identity etc., are not being used by the application. This app is part of the Privacy Friendly Apps group develop by Technische Universität Darmstadt, Germany. More information can be found under https://secuso.org/pfa

##Building

The app can be installed by using IntelliJ or Android Studio (we recommend to use version 2.2.2 or higher).

1. Download the source code: $ git clone https://github.com/SecUSo/privacy-friendly-shopping-list.git
2. Add the local.properties and the build.properties file to the root by removing the extension ".copy" from "local.properties.copy" and "build.gradle.copy"
3. Open the IDE of your choice
4. Connect the mobile device to the computer
5. Setup a Run Configuration "Android Application" and select "app" under Module
6. Click run and select "Choose a running device" from the "Device Chooser" Dialog

### API Reference

Mininum SDK: 17
Target SDK: 25

## License

Copyright 2016 by Grebiel J. Ifill B. and Christian König

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

The icons used in the nagivation drawer are licensed under the [CC BY 2.5] (http://creativecommons.org/licenses/by/2.5/). In addition to them the app uses icons from [Google Design Material Icons](https://design.google.com/icons/index.html) licensed under Apache License Version 2.0. All other images (the logo of Privacy Friendly Apps, the SECUSO logo, the app logo and the splash screen icon) copyright [Technische Universtität Darmstadt] (www.tu-darmstadt.de) (2016). The logo used for the notifications is part of the main logo of Privacy Friendly Shopping List.

## Contributors

App-Icon: <br/>
Markus Hau<br/>

Github-Users: <br/>
Ifill-Brito<br/>
Chris<br/>
Christopher Beckmann<br/>
Karola Marky<br/>
Peter Mayer
